h = 1/12; beta=0.98^(1/12); eta=1; lambda=2; gamma=0.8; mur=h*7/100; sigmar=sqrt(h)*20/100; rf = h*2/100; T = 60*1/h;
% standard model:
beta_sum_vec = beta*ones(T,1); for i=2:T; beta_sum_vec(i) = beta_sum_vec(i-1)+beta.^i; end; beta_sum = @(i) beta_sum_vec(i.*(i>0)+1.*(i==0))-beta.*(i==0);
rhoTC = @(i) 1./(1+beta_sum(i));
alphaTC = (mur-rf)./sigmar.^2.*((mur-rf)./sigmar.^2<1)+1.*((mur-rf)./sigmar.^2>=1);
% news-utility model
gl_const = eta*(lambda-1)*intap(@(s) normpdf(s).*intap(@(stilde) normpdf(stilde).*(s-stilde),s,8),-8,8);
rho = @(i,Fr) 1./(1+beta_sum(i).*(1+gamma.*(eta.*Fr+eta.*lambda.*(1-Fr)))./(1+eta.*Fr+eta.*lambda.*(1-Fr)));
rho_in = @(i) 1/(1+beta_sum(i));
alpha = @(i,j1,Fr) ((mur-rf+(1+gamma.*beta_sum(i-j1+1))./(1+beta_sum(i-j1+1)).*sqrt(j1)./j1.*sigmar.*gl_const./(1+gamma.*(eta.*Fr+eta.*lambda.*(1-Fr))))./sigmar.^2).*(((mur-rf+((1+gamma.*beta_sum(i-j1+1)))./(1+beta_sum(i-j1+1)).*sqrt(j1)./j1.*sigmar.*gl_const./(1+gamma.*(eta.*Fr+eta.*lambda.*(1-Fr))))./sigmar.^2)>0);
n = 80; r_grid = (mur-8*sigmar:16*sigmar/(n-1):mur+8*sigmar)'; Fr_grid = normcdf(r_grid,mur,sigmar);
alpha_grid = zeros(n,3); alpha_grid(:,1) = alpha(10*12,6,Fr_grid); alpha_grid(:,2) = alpha(20*12,12,Fr_grid); alpha_grid(:,3) = alpha(40*14,14,Fr_grid);  % for i=2:length(j1_vec); alpha_grid(:,i) = alpha(T-j1_vec(i),j1_vec(i-1)-j1_vec(i),normcdf(r_grid)); end;
alphaTC = 1;
r_grid = (mur/h-8*sigmar/sqrt(h):16*sigmar/sqrt(h)/(n-1):mur/h+8*sigmar/sqrt(h))';
close all; figure(1); plot(r_grid,alpha_grid(:,1),'*-',r_grid,alpha_grid(:,2),'+-',r_grid,alpha_grid(:,3),'x-',r_grid,[alphaTC*ones(n,1)],'.-','LineWidth',2);
h = legend('at age 50 and $j_1=6$ months inattentive','at age 40 and $j_1=12$ months inattentive','at age 20 and $j_1=14$ months inattentive','standard agent at age 50, 40, and 20','Location','NorthWest'); set(h,'Interpreter','latex'); legend BOXOFF
LEG = findobj(h,'type','text'); axis([r_grid(1) r_grid(end) 0 1]); set(LEG,'FontSize',12)
ylabel('portfolio share','FontSize',28); xlabel('log return realization','FontSize',28);
saveas(gcf,'alpha_inatt.png')

lambda = 2.5; gl_const = eta*(lambda-1)*intap(@(s) normpdf(s).*intap(@(stilde) normpdf(stilde).*(s-stilde),s,8),-8,8);
alpha = @(i,j1,Fr) ((mur-rf+(1+gamma.*beta_sum(i-j1+1))./(1+beta_sum(i-j1+1)).*sqrt(j1)./j1.*sigmar.*gl_const./(1+gamma.*(eta.*Fr+eta.*lambda.*(1-Fr))))./sigmar.^2).*(((mur-rf+((1+gamma.*beta_sum(i-j1+1)))./(1+beta_sum(i-j1+1)).*sqrt(j1)./j1.*sigmar.*gl_const./(1+gamma.*(eta.*Fr+eta.*lambda.*(1-Fr))))./sigmar.^2)>0);
alpha_grid = zeros(n,3); alpha_grid(:,1) = alpha(10*12,6,Fr_grid); alpha_grid(:,2) = alpha(20*12,12,Fr_grid); alpha_grid(:,3) = alpha(40*12,14,Fr_grid);  % for i=2:length(j1_vec); alpha_grid(:,i) = alpha(T-j1_vec(i),j1_vec(i-1)-j1_vec(i),normcdf(r_grid)); end;
close all; figure(1); plot(r_grid,alpha_grid(:,1),'*-',r_grid,alpha_grid(:,2),'+-',r_grid,alpha_grid(:,3),'x-',r_grid,[alphaTC*ones(n,1)],'.-','LineWidth',2);
h = legend('at age 50 and $j_1=6$ months inattentive','at age 40 and $j_1=12$ months inattentive','at age 20 and $j_1=14$ months inattentive','standard agent at age 50, 40, and 20','Location','NorthWest'); set(h,'Interpreter','latex'); legend BOXOFF
LEG = findobj(h,'type','text'); axis([r_grid(1) r_grid(end) 0 1]); set(LEG,'FontSize',12)
ylabel('portfolio share','FontSize',28); xlabel('log return realization','FontSize',28);
saveas(gcf,'alpha_inatt2.png')
