function [fit] = LCPCStrEst(beta,theta,eta,lambda,gamma)
try
% parameter values:
h = 1; r = h*0.0086; Rf = exp(r); sigmau = sqrt(h)*0.1; muu = 0; sigmar = sqrt(h)*19.4/100; mur = h*(r*100+6.33)/100;  correl = 0.44; % then corr(R_grid,U_grid) = 0.2011;
G = 1; p = 0.01; par = [0 muu 0 sigmau r beta theta eta lambda gamma p G mur sigmar]; anl = 0;
% utility function:
u = @(x) x.^(1-theta)./(1-theta); u1 = @(x) ((1-theta).*x).^(1./(1-theta)); up = @(x) x.^(-theta); up1 = @(x) x.^(-1/theta); up1p = @(x) (-1/theta)*x.^(-1/theta-1); upp = @(x) -theta*x.^(-theta-1);
% load labor income profile:
load('PCPartInc_sm.mat','age','partic','share','y');
T = (age(end)-age(1)+1)*1/h; diffy = abs(y(2:end)-y(1:end-1)); Ret = T-find(diffy==max(diffy)); par = [par Ret];
G = ones(T,1); P = ones(T,1); P = [exp(y)./exp(y(1))]; ui = 0.4*P(1); % for i=1:T-1; G(i) = P(T+1-i)/P(T+1-(i+1)); end; G(1:Ret-1) = 1;

% non-stochastic labor income (retirement)
% risky return grid: 
m = 20; [r_grid w_grid] = lgwt(m,mur-3*sigmar,mur+3*sigmar); r_grid = flipdim(r_grid,1); w_grid = flipdim(w_grid,1);
FR_grid = normcdf(r_grid,mur,sigmar); fR_grid = normpdf(r_grid,mur,sigmar); R_grid = exp(r_grid); RR_grid = R_grid; wR_grid = normpdf(r_grid',mur,sigmar).*w_grid';
% savings and portfolio share grids:
n = 20; A_max = 15; A_min = 0.1; A_grid = linspace(A_min,A_max,n)'; 
o = 20; alpha_min = 0; alpha_max = 1; alpha_grid = linspace(alpha_min,alpha_max,o)';
% cash-on-hand-grid XR: rows real of return columns savings and third dimension portfolio share
XR_grid = zeros(m,n,o); Rp = @(R,alpha) Rf+alpha.*(R-Rf); for a=1:o; XR_grid(:,:,a) = kron(A_grid',ones(m,1)).*(Rf+alpha_grid(a)*kron((R_grid-Rf),ones(1,n)))./G(1)+ones(m,n)*P(end); end;
% during retirement: psi and Q are functions of the two state variables savings and portfolio share - savings rows share columns third dimension time
psiR_grid = zeros(n,o,Ret); QR_grid = zeros(n,o,Ret); psiRa_grid = zeros(n,o,Ret); QRa_grid = zeros(n,o,Ret);
% during retirement: consumption and portolio shares depend on savings, past portfolio share, and realization of return -- rows realization of return, columns savings, third dimension past portfolio share
CR_grid = zeros(m,n,o,Ret); CR_grid(:,:,:,1) = XR_grid; alphaR_gridf = zeros(m,n,o,Ret); CpR_grid = zeros(m,n,o,Ret); CpR_grid(:,:,:,1) = ones(m,n,o);
if Ret>1 && anl == 0; i = 1;
for a=1:o; for k=1:n; QRa_grid(k,a,1) = A_grid(k)^(theta).*(beta*(wR_grid*[A_grid(k).*(R_grid-Rf).*up(G(i)).*up(XR_grid(:,k,a))])); end; end;
for a=1:o; for k=1:n; QR_grid(k,a,1) = A_grid(k)^theta.*(beta*(wR_grid*[(Rf+alpha_grid(a).*(R_grid-Rf)).*up(G(i)).*up(XR_grid(:,k,a))])); end; end;
for a=1:o; for k=1:n; psiRa_grid(k,a,1) = A_grid(k)^(theta).*(beta*(wR_grid*[A_grid(k).*(R_grid-Rf).*up(G(i)).*up(XR_grid(:,k,a))])+beta*eta*(lambda-1)*(wR_grid*[wR_grid*[(kron((A_grid(k).*(R_grid-Rf).*up(G(i)).*up(XR_grid(:,k,a)))',ones(m,1))-kron(A_grid(k).*(R_grid-Rf).*up(G(i)).*up(XR_grid(:,k,a)),ones(1,m))).*(kron(XR_grid(:,k,a),ones(1,m))>=kron(XR_grid(:,k,a)',ones(m,1)))]]')); end; end;
for a=1:o; for k=1:n; psiR_grid(k,a,1) = A_grid(k)^theta.*(beta*(wR_grid*[(Rf+alpha_grid(a).*(R_grid-Rf)).*up(G(i)).*up(XR_grid(:,k,a))])+beta*eta*(lambda-1)*(wR_grid*[wR_grid*[(kron(((Rf+alpha_grid(a).*(R_grid-Rf)).*up(G(i)).*up(XR_grid(:,k,a)))',ones(m,1))-kron((Rf+alpha_grid(a).*(R_grid-Rf)).*up(G(i)).*up(XR_grid(:,k,a)),ones(1,m))).*(kron(XR_grid(:,k,a),ones(1,m))>=kron(XR_grid(:,k,a)',ones(m,1)))]]')); end; end;
[rho_grid alphaRet_grid] = RetLCPC(par,alphaR_gridf);
    for i = 2:Ret;
    for a=1:o; XR_grid(:,:,a) = kron(A_grid',ones(m,1)).*(Rf+alpha_grid(a)*kron((R_grid-Rf),ones(1,n)))./G(i)+ones(m,n)*P(end-i+1);
    alphaR_gridf(:,:,a,i) = kron(alphaRet_grid(:,i),ones(1,n)).*(1+1./Rf./XR_grid(:,:,a)); end;
    end
for i = 2:Ret
    for a=1:o; XR_grid(:,:,a) = kron(A_grid',ones(m,1)).*(Rf+alpha_grid(a)*kron((R_grid-Rf),ones(1,n)))./G(i)+ones(m,n)*P(end-i+1); end;
    [psiR_grid,QR_grid,psiRa_grid,QRa_grid,CR_grid,CpR_grid,alphaR_gridf] = RecLCPCnum(psiR_grid,QR_grid,psiRa_grid,QRa_grid,CR_grid,CpR_grid,alphaR_gridf,XR_grid,R_grid,wR_grid,FR_grid,fR_grid,A_grid,alpha_grid,par,G,u,u1,up,upp,up1,T,i,A_min);
end
elseif Ret>1 && anl == 1;
i = 1; [rho_grid alphaRet_grid] = RetLCPC(par,alphaR_gridf);
for a=1:o; for k=1:n; QRa_grid(k,a,1) = A_grid(k)^(theta).*(beta*(wR_grid*[A_grid(k).*(R_grid-Rf).*up(G(i)).*up(XR_grid(:,k,a))])); end; end;
for a=1:o; for k=1:n; QR_grid(k,a,1) = A_grid(k)^theta.*(beta*(wR_grid*[(Rf+alpha_grid(a).*(R_grid-Rf)).*up(G(i)).*up(XR_grid(:,k,a))])); end; end;
for a=1:o; for k=1:n; psiRa_grid(k,a,1) = A_grid(k)^(theta).*(beta*(wR_grid*[A_grid(k).*(R_grid-Rf).*up(G(i)).*up(XR_grid(:,k,a))])+beta*eta*(lambda-1)*(wR_grid*[wR_grid*[(kron((A_grid(k).*(R_grid-Rf).*up(G(i)).*up(XR_grid(:,k,a)))',ones(m,1))-kron(A_grid(k).*(R_grid-Rf).*up(G(i)).*up(XR_grid(:,k,a)),ones(1,m))).*(kron(XR_grid(:,k,a),ones(1,m))>=kron(XR_grid(:,k,a)',ones(m,1)))]]')); end; end;
for a=1:o; for k=1:n; psiR_grid(k,a,1) = A_grid(k)^theta.*(beta*(wR_grid*[(Rf+alpha_grid(a).*(R_grid-Rf)).*up(G(i)).*up(XR_grid(:,k,a))])+beta*eta*(lambda-1)*(wR_grid*[wR_grid*[(kron(((Rf+alpha_grid(a).*(R_grid-Rf)).*up(G(i)).*up(XR_grid(:,k,a)))',ones(m,1))-kron((Rf+alpha_grid(a).*(R_grid-Rf)).*up(G(i)).*up(XR_grid(:,k,a)),ones(1,m))).*(kron(XR_grid(:,k,a),ones(1,m))>=kron(XR_grid(:,k,a)',ones(m,1)))]]')); end; end;
for i = 2:Ret;
    for a=1:o; XR_grid(:,:,a) = kron(A_grid',ones(m,1)).*(Rf+alpha_grid(a)*kron((R_grid-Rf),ones(1,n)))./G(i)+ones(m,n)*P(end-i+1);
    CR_grid(:,:,a,i) = XR_grid(:,:,a).*kron(rho_grid(:,i),ones(1,n)); 
    alphaR_gridf(:,:,a,i) = kron(alphaRet_grid(:,i),ones(1,n)).*(1+1./Rf./XR_grid(:,:,a)); end;
    CpR_grid(:,:,a,i) = kron(rho_grid(:,i),ones(1,n)); 
    psi = griddedInterpolant({[A_grid],alpha_grid},[psiR_grid(:,:,i-1)]); psi = @(A,alpha) max(psi(A,alpha),-1./psi(A,alpha));
    Q = griddedInterpolant({[A_grid],alpha_grid},[QR_grid(:,:,i-1)]); Q = @(A,alpha) max(Q(A,alpha),-1./Q(A,alpha));
    psi = griddedInterpolant({[0; A_grid; 10*A_grid(end)],alpha_grid},[psiR_grid(1,:,i-1); psiR_grid(:,:,i-1); psiR_grid(end,:,i-1)]);
    Q = griddedInterpolant({[0; A_grid; 10*A_grid(end)],alpha_grid},[QR_grid(1,:,i-1); QR_grid(:,:,i-1); QR_grid(end,:,i-1)]);
    for a = 1:o; 
        for k = 1:n;
        QR_grid(k,a,i) = A_grid(k)^theta.*abs(beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*CpR_grid(:,k,a,i).*up(G(i)).*up(CR_grid(:,k,a,i))]+beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*(1-CpR_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-CR_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-CR_grid(:,k,a,i),alphaR_gridf(:,k,a,i))]);
        QRa_grid(k,a,i) = A_grid(k)^(theta).*(beta*wR_grid*[A_grid(k).*(R_grid-Rf).*CpR_grid(:,k,a,i).*up(G(i)).*up(CR_grid(:,k,a,i))]+beta*wR_grid*[A_grid(k).*(R_grid-Rf).*(1-CpR_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-CR_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-CR_grid(:,k,a,i),alphaR_gridf(:,k,a,i))]);
        psiR_grid(k,a,i) = A_grid(k)^theta.*abs(beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*CpR_grid(:,k,a,i).*up(G(i)).*up(CR_grid(:,k,a,i))]+beta*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((Rp(R_grid,alpha_grid(a)).*CpR_grid(:,k,a,i).*up(G(i)).*up(CR_grid(:,k,a,i)))',ones(m,1))-kron(Rp(R_grid,alpha_grid(a)).*CpR_grid(:,k,a,i).*up(G(i)).*up(CR_grid(:,k,a,i)),ones(1,m))).*(kron(CR_grid(:,k,a,i),ones(1,m))>=kron(CR_grid(:,k,a,i)',ones(m,1)))]]'+beta*gamma*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((Rp(R_grid,alpha_grid(a)).*(1-CpR_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-CR_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-CR_grid(:,k,a,i),alphaR_gridf(:,k,a,i)))',ones(m,1))-kron(Rp(R_grid,alpha_grid(a)).*(1-CpR_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-CR_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-CR_grid(:,k,a,i),alphaR_gridf(:,k,a,i)),ones(1,m))).*(kron(XR_grid(:,k,a)-CR_grid(:,k,a,i),ones(1,m))>=kron((XR_grid(:,k,a)-CR_grid(:,k,a,i))',ones(m,1)))]]'+beta*wR_grid*[Rp(R_grid,alpha_grid(a)).*(1-CpR_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-CR_grid(:,k,a,i)).^(-theta).*psi(XR_grid(:,k,a)-CR_grid(:,k,a,i),alphaR_gridf(:,k,a,i))]);
        psiRa_grid(k,a,i) = A_grid(k)^(theta).*(beta*wR_grid*[A_grid(k).*(R_grid-Rf).*CpR_grid(:,k,a,i).*up(G(i)).*up(CR_grid(:,k,a,i))]+beta*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((A_grid(k).*(R_grid-Rf).*CpR_grid(:,k,a,i).*up(G(i)).*up(CR_grid(:,k,a,i)))',ones(m,1))-kron(A_grid(k).*(R_grid-Rf).*CpR_grid(:,k,a,i).*up(G(i)).*up(CR_grid(:,k,a,i)),ones(1,m))).*(kron(CR_grid(:,k,a,i),ones(1,m))>=kron(CR_grid(:,k,a,i)',ones(m,1)))]]'+beta*gamma*eta*(lambda-1)*wR_grid*[wR_grid*[(kron((A_grid(k).*(R_grid-Rf).*(1-CpR_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-CR_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-CR_grid(:,k,a,i),alphaR_gridf(:,k,a,i)))',ones(m,1))-kron(A_grid(k).*(R_grid-Rf).*(1-CpR_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-CR_grid(:,k,a,i)).^(-theta).*Q(XR_grid(:,k,a)-CR_grid(:,k,a,i),alphaR_gridf(:,k,a,i)),ones(1,m))).*(kron(XR_grid(:,k,a)-CR_grid(:,k,a,i),ones(1,m))>=kron((XR_grid(:,k,a)-CR_grid(:,k,a,i))',ones(m,1)))]]'+beta*wR_grid*[A_grid(k).*(R_grid-Rf).*(1-CpR_grid(:,k,a,i)).*up(G(i)).*(XR_grid(:,k,a)-CR_grid(:,k,a,i)).^(-theta).*psi(XR_grid(:,k,a)-CR_grid(:,k,a,i),alphaR_gridf(:,k,a,i))]);
        end;
    end
end
end

% stochastic labor income (before retirement)
% risky return grid:
[r_grid w_grid] = lgwt(m,mur-3*sigmar,mur+3*sigmar); r_grid = flipdim(r_grid,1); w_grid = flipdim(w_grid,1);
FR_grid = normcdf(r_grid,mur,sigmar); fR_grid = normpdf(r_grid,mur,sigmar); R_grid = exp(r_grid); wR_grid = normpdf(r_grid',mur,sigmar).*w_grid';
% labor income grid:
M = 3; U_grid = ones(m*M,1); FU_grid = U_grid; fU_grid = U_grid; wU_grid = U_grid';
if M == 1; p = 1; fU_grid = 1; FU_grid = 1; wU_grid = 1;
elseif M < 16 && M>1; 
for j=1:m [u_grid w_grid] = lgwt(M-1,muu+sigmau.*(correl.*(r_grid(j)-mur)./sigmar+sqrt(1-correl^2)*(muu-3*sigmau-muu)/sigmau),muu+sigmau.*(correl.*(r_grid(j)-mur)./sigmar+sqrt(1-correl^2)*(muu+3*sigmau-muu)/sigmau)); 
       u_grid = flipdim(u_grid,1); w_grid = flipdim(w_grid,1); u_grid(2:end-1) = muu+sigmau.*(correl.*(r_grid(j)-mur)./sigmar+sqrt(1-correl^2)*(u_grid(2:end-1)-muu)/sigmau);
if M == 2; u_grid = [muu+sigmau.*(correl.*(r_grid(j)-mur)./sigmar+sqrt(1-correl^2)*(muu-muu)/sigmau)]; end; if M == 3; u_grid = [muu+sigmau.*(correl.*(r_grid(j)-mur)./sigmar+sqrt(1-correl^2)*(muu-sigmau-muu)/sigmau); muu+sigmau.*(correl.*(r_grid(j)-mur)./sigmar+sqrt(1-correl^2)*(muu+sigmau-muu)/sigmau)]; end;
fU_grid(1+(j-1)*M:(j-1)*M+M) = [p; ones(M-1,1)*(1-p)/(M-1)]; FU_grid(1+(j-1)*M:(j-1)*M+M) = [fU_grid(1+(j-1)*M:(j-1)*M+M)'*triu(ones(M,M))]'; U_grid(1+(j-1)*M:(j-1)*M+M) = [ui; exp(u_grid)]; wU_grid = fU_grid';
end
elseif M > 16 && M>1;
for j=1:m [u_grid w_grid] = lgwt(M-1,muu+sigmau.*(correl.*(r_grid(j)-mur)./sigmar+sqrt(1-correl^2)*(muu-3*sigmau-muu)/sigmau),muu+sigmau.*(correl.*(r_grid(j)-mur)./sigmar+sqrt(1-correl^2)*(muu+3*sigmau-muu)/sigmau)); 
       u_grid = flipdim(u_grid,1); w_grid = flipdim(w_grid,1); u_grid(2:end-1) = muu+sigmau.*(correl.*(r_grid(j)-mur)./sigmar+sqrt(1-correl^2)*(u_grid(2:end-1)-muu)/sigmau);
FU_grid(1+(j-1)*M:(j-1)*M+M) = [p; p+(1-p)*normcdf(u_grid,muu,sigmau)]; fU_grid(1+(j-1)*M:(j-1)*M+M) = [p; (1-p)*normpdf(u_grid,muu,sigmau)]; U_grid(1+(j-1)*M:(j-1)*M+M) = [ui; exp(u_grid)]; wU_grid(1+(j-1)*M:(j-1)*M+M) = [p (1-p)*normpdf(u_grid',muu,sigmau).*w_grid'];
end;
end;
R_grid = kron(R_grid,ones(M,1)); % corr(R_grid,U_grid)
% joint grids:
F_grid = kron(FR_grid,ones(M,1)).*FU_grid; f_grid = kron(fR_grid,ones(M,1)).*fU_grid; w_grid = kron(wR_grid,ones(1,M)).*wU_grid;
% cash-on-hand grid: X first dimension real of return and labor, columns savings, and third dimension past portfolio share
X_grid = zeros(m*M,n,o); w1_grid = X_grid; F1_grid = X_grid; f1_grid = X_grid; R1_grid = X_grid;
% psi function of savings and portfolio share - savings rows alpha columns third dimension time
psi_grid = zeros(n,o,T); Q_grid = zeros(n,o,T); psia_grid = zeros(n,o,T); Qa_grid = zeros(n,o,T);
psi_grid(:,:,Ret) = psiR_grid(:,:,Ret); Q_grid(:,:,Ret) = QR_grid(:,:,Ret); psia_grid(:,:,Ret) = psiRa_grid(:,:,Ret); Qa_grid(:,:,Ret) = QRa_grid(:,:,Ret);
% consumption and portfolio share depends on savings and past portfolio share and realization of return and labor income -- rows realization of return and labor income, columns savings, third dimension past portfolio share
C_grid = zeros(m*M,n,o,T); Cp_grid = zeros(m*M,n,o,T); alpha_gridf = zeros(m*M,n,o,T);
for i = Ret+1:T
    for a = 1:o; for k=1:n; X_grid(:,k,a) = A_grid(k).*(Rf+alpha_grid(a)*(R_grid-Rf))./G(i)+U_grid*P(end-i+1); [X_grid(:,k,a) ix] = sort(X_grid(:,k,a)); w1_grid(:,k,a) = w_grid(ix)'; f1_grid(:,k,a) = f_grid(ix); R1_grid(:,k,a) = R_grid(ix); F1_grid(:,k,a) = [f1_grid(:,k,a)'*triu(ones(M*m,M*m))]'/sum(f1_grid(:,k,a)); end; end;
    [psi_grid,Q_grid,psia_grid,Qa_grid,C_grid,Cp_grid,alpha_gridf] = RecLCPCnum(psi_grid,Q_grid,psia_grid,Qa_grid,C_grid,Cp_grid,alpha_gridf,X_grid,R1_grid,w1_grid,F1_grid,f1_grid,A_grid,alpha_grid,par,G,u,u1,up,upp,up1,T,i,A_min);
end

N = 1000; C = zeros(T,N); A = zeros(T,N); X = zeros(T,N); P = [exp(y)./exp(y(1))]; alpha = zeros(T,N); u_mat = muu*ones(T,N); p_mat = ones(T,N); r_mat = mur*ones(T,N); k_vec = 0;
load('LCPCsim.mat','u_mat','r_mat','p_mat','A0_vec');
for k=1:N
try A0 = A0_vec(k); u_val = u_mat(:,k); p_val = p_mat(:,k); r_val = r_mat(:,k);
    X(1,k) = A0*Rf+P(1)*exp(u_val(1)).*p_val(1); X1_grid = sort(A0*Rf+P(1)*U_grid); C(1,k) = interpn([squeeze(X1_grid(diff(X1_grid)>0)); X1_grid(end)],A_grid,[squeeze(C_grid((diff(X1_grid)>0),:,1,T)); C_grid(end,:,1,T)],X(1,k),A0,'linear'); A(1,k) = X(1,k)-C(1,k);
    alpha(1,k) = interpn([squeeze(X1_grid(diff(X1_grid)>0)); X1_grid(end)],A_grid,[squeeze(alpha_gridf((diff(X1_grid)>0),:,round(o/o),T)); alpha_gridf(end,:,round(o/o),T)],X(1,k),A0,'linear');
for j=2:T-Ret
    X(j,k) = A(j-1,k)*(Rf+alpha(j-1,k)*(exp(r_val(j))-Rf))+P(j)*exp(u_val(j))*p_val(j); Xj_grid = sort(A(j-1,k)*(Rf+alpha(j-1,k)*(R_grid-Rf))+P(j)*U_grid);
    Cj1_grid = squeeze(C_grid((diff(Xj_grid)>0),:,:,T-j+1)); Cj_grid = zeros(size(Cj1_grid(:,:,1),1),n+2,o); for kk = 1:o; Cj_grid(:,:,kk) = [zeros(size(Cj1_grid(:,:,kk),1),1) Cj1_grid(:,:,kk) Cj1_grid(:,end,kk)*10]; end; C(j,k) = interpn(squeeze(Xj_grid(diff(Xj_grid)>0)),[0; A_grid; A_grid(end)*10],alpha_grid,Cj_grid,X(j,k),A(j-1,k),alpha(j-1,k),'linear'); A(j,k) = X(j,k)-C(j,k);
    alphaj1_grid = squeeze(alpha_gridf((diff(Xj_grid)>0),:,:,T-j+1)); alphaj_grid = zeros(size(alphaj1_grid(:,:,1),1),n+2,o); for kk = 1:o; alphaj_grid(:,:,kk) = [alphaj1_grid(:,1,kk) alphaj1_grid(:,:,kk) alphaj1_grid(:,end,kk)]; end;
    alpha(j,k) = interpn(squeeze(Xj_grid(diff(Xj_grid)>0)),[0; A_grid; A_grid(end)*10],alpha_grid,alphaj_grid,X(j,k),A(j-1,k),alpha(j-1,k),'linear');
end
if Ret>1
for j=T-Ret+1:T
    X(j,k) = A(j-1,k)*(Rf+alpha(j-1,k)*(exp(r_val(j))-Rf))+P(j);
    Cj1_grid = CR_grid(:,:,:,T+1-j); Cj_grid = zeros(m,n+2,o); for kk = 1:o; Cj_grid(:,:,kk) = [zeros(size(Cj1_grid(:,:,kk),1),1) Cj1_grid(:,:,kk) Cj1_grid(:,end,kk)*10]; end; 
    C(j,k) = interpn(RR_grid,[0; A_grid; A_grid(end)*10],alpha_grid,Cj_grid,exp(r_val(j)),A(j-1,k),alpha(j-1,k),'linear'); A(j,k) = X(j,k)-C(j,k);
    alphaj1_grid = alphaR_gridf(:,:,:,T+1-j); alphaj_grid = zeros(m,n+2,o); for kk = 1:o; alphaj_grid(:,:,kk) = [zeros(size(alphaj1_grid(:,:,kk),1),1) alphaj1_grid(:,:,kk) alphaj1_grid(:,end,kk)*10]; end; 
    alpha(j,k) = interpn(RR_grid,[0; A_grid; A_grid(end)*10],alpha_grid,alphaj_grid,exp(r_val(j)),A(j-1,k),alpha(j-1,k),'linear'); alpha = min(max(alpha,0),1);
end
else
    j = T;
    X(j,k) = A(j-1,k)*(Rf+alpha(j-1,k)*(exp(r_val(j))-Rf))+P(j)*exp(u_val(j))*p_val(j); C(j,k) = X(j,k); A(j,k) = X(j,k)-C(j,k); alpha(j,k) = 0;
end
if sum(isnan(C(:,k)))>0 || sum(isnan(alpha(:,k)))>0; k_vec = [k_vec; k]; end; 
catch err; k_vec = [k_vec; k]; end 
end; k_vec = k_vec(2:end,1)'; C(:,k_vec)=[]; alpha(:,k_vec)=[]; A(:,k_vec)=[]; X(:,k_vec)=[];
P = log(P*exp(y(1))); C = log(C*exp(y(1))); A = [log(A(1:end-1,:)*exp(y(1))); A(end,:)]; 
alpha_sim = alpha; C = mean(C,2); A = mean(A,2); part = sum(alpha_sim>=alpha_grid(2),2)./N; alpha = sum(alpha,2)./(sum(alpha>0,2)+ones(T,1).*(sum(alpha>0,2)==0));
close all; plot(1:T,C,'x-m',1:T,y(1:T),'+-k','LineWidth',2);
ylabel('Consumption and income','FontSize',17); xlabel('time periods t=1,...,54 (age 25 to 78)','FontSize',17);
saveas(gcf,'C_est.png');
close all; plot(1:T,alpha,'*-m',1:T,share(1:T),'+-k','LineWidth',2);
ylabel('Portfolio share','FontSize',17); xlabel('time periods t=1,...,54 (age 25 to 78)','FontSize',17);
saveas(gcf,'alpha_est.png');
close all; plot(1:T,part,'*-m',1:T,partic(1:T),'+k','LineWidth',2); axis([0 60 0 1]);
ylabel('participation','FontSize',17); xlabel('time periods t=1,...,54 (age 25 to 78)','FontSize',17);
saveas(gcf,'part_est.png')

fit = alpha;
catch err; fit = ones(T,1); return; end;