% Structural estimation
options = optimset('MaxIter',5000,'MaxFunEvals',5000,'Display','iter','OutputFcn',@outfun);
load('PCPartInc_sm.mat','age','partic','share','y'); load('VarPCPartInc_sm.mat','Vshare');
load('strest2.mat'); beta = x(1); theta = x(2); eta = x(3); lambda = x(4); gamma = x(5); x = [beta,theta,eta,lambda,gamma];
[x,fval,exitflag] = fminsearch(@(x) sum((LCPCStrEst(x(1),x(2),x(3),x(4),x(5))-share).^2./Vshare),[beta,theta,eta,lambda,gamma],options)
T = length(share); dof = T-length(x);
J = zeros(T,5); alpha = LCPCStrEst(x(1),x(2),x(3),x(4),x(5)); 
J(:,1) =  (LCPCStrEst(x(1)+0.001,x(2),x(3),x(4),x(5))-alpha)./0.001;
J(:,2) =  (LCPCStrEst(x(1),x(2)+0.001,x(3),x(4),x(5))-alpha)./0.001;
J(:,3) =  (LCPCStrEst(x(1),x(2),x(3)+0.001,x(4),x(5))-alpha)./0.001;
J(:,4) =  (LCPCStrEst(x(1),x(2),x(3),x(4)+0.001,x(5))-alpha)./0.001;
J(:,5) =  (LCPCStrEst(x(1),x(2),x(3),x(4),x(5)+0.001)-alpha)./0.001;
fval = sum(((alpha-share).^2./Vshare)) % chi-squared distributed with dof
chi2inv(0.95,T-2)
Sigma = fval*inv(J'*J);
se = sqrt(diag(Sigma))'
save('strest.mat')
