clear all
close all
pause on
% static model:
eta=1; lambda=2; mur=7/100; sigmar=20/100; rf = 2/100;
% standard model:
alphaTC = (mur-rf)./sigmar.^2;
% news-utility model
gl_const = eta*(lambda-1)*intap(@(s) normpdf(s).*intap(@(stilde) normpdf(stilde).*(s-stilde),s,8),-8,8);
alpha = @(h) (mur-rf+sqrt(h)./h.*sigmar.*gl_const)./sigmar.^2.*((mur-rf+sqrt(h)./h.*sigmar.*gl_const)./sigmar.^2>0);
lambda = 2.5; gl_const = eta*(lambda-1)*intap(@(s) normpdf(s).*intap(@(stilde) normpdf(stilde).*(s-stilde),s,8),-8,8);
alpha1 = @(h) (mur-rf+sqrt(h)./h.*sigmar.*gl_const)./sigmar.^2.*((mur-rf+sqrt(h)./h.*sigmar.*gl_const)./sigmar.^2>0);
lambda = 3; gl_const = eta*(lambda-1)*intap(@(s) normpdf(s).*intap(@(stilde) normpdf(stilde).*(s-stilde),s,8),-8,8);
alpha2 = @(h) (mur-rf+sqrt(h)./h.*sigmar.*gl_const)./sigmar.^2.*((mur-rf+sqrt(h)./h.*sigmar.*gl_const)./sigmar.^2>0);
n = 80; h_grid = (1/12:(20-1/12)/(n-1):20)';
plot(h_grid,alphaTC*ones(n,1),'+-',h_grid,alpha(h_grid),'*-',h_grid,alpha1(h_grid),'*-',h_grid,alpha2(h_grid),'*-','LineWidth',2);
h = legend('standard $\eta(\lambda-1)=0$','news utility $\eta(\lambda-1)=1$','news utility $\eta(\lambda-1)=1.5$','news utility $\eta(\lambda-1)=2$','Location','Best'); set(h,'Interpreter','latex'); legend BOXOFF
LEG = findobj(h,'type','text'); set(LEG,'FontSize',12) 
ylabel('portfolio share','FontSize',28); xlabel('investment period 1 month to 20 years','FontSize',28);
saveas(gcf,'stalpha.png')
lambda = 2; gl_const = eta*(lambda-1)*intap(@(s) normpdf(s).*intap(@(stilde) normpdf(stilde).*(s-stilde),s,8),-8,8);
pause
close all; lambda = 3; h = 10; gl_const = @(lambda) eta*(lambda-1)*intap(@(s) normpdf(s).*intap(@(stilde) normpdf(stilde).*(s-stilde),s,8),-8,8);
alpha = @(lambda) (mur-rf+sqrt(h)./h.*sigmar.*gl_const(lambda))./sigmar.^2.*((mur-rf+sqrt(h)./h.*sigmar.*gl_const(lambda))./sigmar.^2>0);
n = 80; lambda_grid = (1:(3-1)/(n-1):3)';
plot(lambda_grid-1,alphaTC*ones(n,1),'+-',lambda_grid-1,alpha(lambda_grid),'*-','LineWidth',2);
h = legend('standard $\eta(\lambda-1)=0$','news utility $\eta(\lambda-1)>0$','Location','Best'); set(h,'Interpreter','latex'); legend BOXOFF
LEG = findobj(h,'type','text'); set(LEG,'FontSize',12) 
ylabel('portfolio share','FontSize',28); xlabel('loss aversion \eta(\lambda-1)','FontSize',28);
saveas(gcf,'lambdaalpha.png')
