clear
set more off
pause on
global direct = "...\CodeLCPC"
set memory 1g
use "$direct\scfbs2007i.dta", clear
append using "$direct\scfbs2004i.dta"
append using "$direct\scfbs2001i.dta"
append using "$direct\scfbs1998i.dta"
append using "$direct\scfbs1995i.dta"
append using "$direct\scfbs1992i.dta"
append using "$direct\scfbs1989i.dta"
replace famsize = 10 if famsize >= 10
drop if age < 25 | age > 78
drop if educ<=1
gen ret = 0
replace ret = 1 if age>60 & LF == 0
gen pcs = equity/fin
gen pcb=bus/networth
drop if pcb<0 | pcb>1
gen pch=homeeq/networth
drop if pch<0 | pch>1
replace pcs = pcs + pcb
gen part = 0
replace part = 1 if pcs>0
replace pcs = . if part == 0
gen id = _n
gen savings=checking+saving
sum negnetworth
gen net = networth-negnetworth
corr pcs net
keep pcs part income age famsize year cohort ret weight id 
/*sum bus
gen mbus = r(mean)
sum homeeq
gen mhomeeq = r(mean)*/
gen mret = 0 
local ret_date = 68
replace mret = 1 if age >= `ret_date'
replace mret = 0 if age < `ret_date'
replace income = log(income)

/*forvalues i = 2/5 {
gen age`i' = age^`i'/10^`i'
}*/
tabulate age, generate(age_)
drop age_1
char famsize[omit] 1
tabulate cohort, generate(_Icohort_)
drop _Icohort_15
drop _Icohort_18
char year[omit] 2007
xi: reg pcs age* i.famsize i.year _Icohort_* ret [iw=weight]
predict ppcs if e(sample)

preserve
replace ret = mret
/// replace homeeq = mhomeeq
/// replace bus = 0
foreach var of varlist _Ifamsize_* _Iyear_* _Icohort_*  {
replace `var' = 0
}
predict spcs
replace spcs = . if part == 0
replace pcs = spcs + pcs - ppcs
replace spcs = . if part == 0
sort id year
save "$direct/NonGroupDum.dta", replace
restore

/// doing the same for participation
xi: reg part age* i.famsize i.year _Icohort_* ret [iw=weight]
predict ppart if e(sample)
preserve
keep id year ppart
sort id year
save "$direct\ppart.dta", replace
use "$direct/NonGroupDum.dta", replace
merge id year using "$direct\ppart.dta"
drop _merge
predict spart
replace part = spart + part - ppart
sort id year
save "$direct/NonGroupDum.dta", replace
restore

/// doing the same for income
xi: reg income age* i.famsize i.year _Icohort_* ret [iw=weight]
predict pincome if e(sample)
keep id year pincome
sort id year
save "$direct\pincome.dta", replace

preserve
use "$direct/NonGroupDum.dta", replace
merge id year using "$direct\pincome.dta"
predict sincome
replace income = sincome + income - pincome
save "$direct/NonGroupUncontamDum.dta", replace
restore

preserve
use "$direct/NonGroupUncontamDum.dta", replace
collapse (mean) pcs (mean) part (mean) income (mean) spcs (mean) spart (mean) sincome, by (age)
label var age "age"
scatter (spcs spart age), msymbol(d s) mcolor(midblue forest_green) title("SCF 1989-2007 portfolio shares and participation") subtitle("controlling for cohort, family size, and time effects", size(large)) xtitle("age", size(large)) msymbol(D S) legend(order(1 "portfolio share" 2 "participation") size(large))
pause
scatter (sincome age), msymbol(d d) mcolor(midblue edkblue) title("SCF 1989-2007 income") subtitle("controlling for cohort, family size, and time effects", size(large)) xtitle("age", size(large)) msymbol(D S) legend(order(1 "income") size(large)) ytitle("")
sort age
outsheet age pcs part income using "$direct\PCInc.txt", replace
outsheet age spcs spart sincome using "$direct\smPCInc.txt", replace
restore

use "$direct/NonGroupUncontamDum.dta", replace
bysort age: gen freq_age = _N
preserve
collapse (sd) pcs (sd) part (sd) income, by (age)
replace pcs = pcs^2
replace part = part^2
replace income = income^2
sort age
outsheet using "$direct\VarMat.txt", replace
restore


