% Calculating prospective news utility over a signal and the expectation of which conditional on a signal
clear all; close all; pause on
beta = 0.98; theta = 4; eta = 1; lambda = 2.5; gamma = 0.8; t = 1; mur = 0.07; sigmar = 0.2; rf = 0.02; Rf = exp(rf);
sigmaeps = sigmar; ut = @(c) c.^(1-theta)./(1-theta); up = @(c) c.^(-theta); if theta == 1; ut = @(c) log(c); up = @(c) c.^(-1); end; 
mu = @(x) eta.*x.*(x>=0)+eta.*lambda.*x.*(x<0);

% expected prospective news utility (unconditional)
nu_unc = @(R) quadv(@(r) gamma*beta*normpdf(r,mur,sigmar).*mu(ut(R)-ut(exp(r))),mur-8*sigmar,mur+8*sigmar);
% expected prospective news utility from looking up the return conditional on the signal Rtilde
nu_conds = @(Rtilde) gamma*beta*quadv(@(y) quadv(@(x) normpdf(x,mur,sigmar).*normpdf(y,0,sigmaeps).*mu(ut(exp(log(Rtilde)-y))-ut(exp(x))),mur-8*sigmar,mur+8*sigmar),-8*sigmaeps,8*sigmaeps);
% prospective news utility over the signal Rtilde
nu_signal = @(Rtilde) gamma*beta*quadv(@(y) quadv(@(xz) normpdf(xz,mur,sqrt(sigmar^2+sigmaeps^2)).*normpdf(y,0,sigmaeps).*mu(ut(exp(log(Rtilde)-y))-ut(exp(xz-y))),mur-8*sqrt(sigmar^2+sigmaeps^2),mur+8*sqrt(sigmar^2+sigmaeps^2)),-8*sigmaeps,8*sigmaeps);

r_vec = [mur-2*sigmar:16*sigmar/80:mur+8*sigmar]';
plot(exp(r_vec),nu_signal(exp(r_vec)),'*-',exp(r_vec),nu_conds(exp(r_vec)),'+-','LineWidth',2);
hh = legend('news utility over the signal','expected news utility conditional on signal','Location','Best'); set(hh,'Interpreter','latex'); legend BOXOFF
LEG = findobj(hh,'type','text'); set(LEG,'FontSize',12)
xlabel('realization of the signal','FontSize',22); ylabel('prospective news utility','FontSize',22); 
saveas(gcf,'Ostrich.png')
pause
close; plot(exp(r_vec),nu_conds(exp(r_vec))-nu_signal(exp(r_vec)),'*-','LineWidth',2);
hh = legend('additional expected news utility conditional on signal','Location','NorthWest'); set(hh,'Interpreter','latex'); legend BOXOFF
LEG = findobj(hh,'type','text'); set(LEG,'FontSize',12)
xlabel('realization of the signal','FontSize',22); ylabel('prospective news utility','FontSize',22); axis([exp(r_vec(1)) exp(r_vec(end)) -0.24 0])
saveas(gcf,'Ostrich1.png')
