% Life-cycle portfolio-choice model semi-analytical solution without labor income
function [rho_grid alpha_grid] = RetLCPC(par,alpha_grid)
beta = par(6); r = par(5); theta = par(7); Rf = exp(r); mur = par(13); sigmar = par(14); Ret = par(end); eta = par(8); lambda = par(9); gamma = par(10); 
n = size(alpha_grid,1); T = Ret; u = @(c) 1/(1-theta)*c.^(1-theta); up = @(c) c.^(-theta); if theta == 1; u = @(c) log(c); up = @(c) 1./c; end;
[r_grid w_grid] = lgwt(n,mur-3*sigmar,mur+3*sigmar); r_grid = flipdim(r_grid,1); w_grid = flipdim(w_grid,1);
FR_grid = normcdf(r_grid,mur,sigmar); R_grid = exp(r_grid); w_grid = normpdf(r_grid',mur,sigmar).*w_grid'; options = optimset('Display','off');
% policy functions:
Rp = @(R,alpha) Rf+alpha.*(R-Rf);
alphaTC = fsolve(@(alpha) w_grid*[((Rf+alpha*(R_grid-Rf)).^(-theta).*(R_grid-Rf))],(mur-log(Rf)+0.5*sigmar^2)/(sigmar^2*theta),options);
alpha = @(R,FR) fsolve(@(alpha) gamma*beta*w_grid*[Rp(R_grid,alpha).^(-theta).*(R_grid-Rf)]*(eta*FR+eta*lambda*(1-FR))...
      +beta*w_grid*[Rp(R_grid,alpha).^(-theta).*(R_grid-Rf)]+beta*eta*(lambda-1)*w_grid*[w_grid*([[kron((Rp(R_grid,alpha).^(-theta).*(R_grid-Rf))',ones(n,1))-kron(Rp(R_grid,alpha).^(-theta).*(R_grid-Rf),ones(1,n))].*(kron(R_grid',ones(n,1))<kron(R_grid,ones(1,n)))])]',alphaTC,options);
alpha_grid = zeros(length(R_grid),T); rho_grid = zeros(length(R_grid),T); rho_grid(:,1) = ones(length(R_grid),1);
for i=1:n
    alpha_grid(i,2) = alpha(R_grid(i),FR_grid(i));
end; alpha_grid(:,2) = min(max(alpha_grid(:,2),0),1);
Rp_grid = Rf+kron(alpha_grid(:,2)',ones(n,1)).*(kron(R_grid,ones(1,n))-Rf); psi_grid = [zeros(T-1,length(R_grid));[beta*w_grid*Rp_grid.^(1-theta)];zeros(1,length(R_grid))];
for j = 1:n; psi_grid(T,j) = psi_grid(T,j)+beta*eta*(lambda-1)*w_grid*[w_grid*[(kron(Rp_grid(:,j).^(1-theta)',ones(n,1))-kron(Rp_grid(:,j).^(1-theta),ones(1,n))).*(kron(Rp_grid(:,j)',ones(n,1))<kron(Rp_grid(:,j),ones(1,n)))]]'; 
end; Q_grid = [zeros(T-1,length(R_grid));[beta*w_grid*Rp_grid.^(1-theta)];zeros(1,length(R_grid))]; QTC_grid = [zeros(T-1,1);[beta*w_grid*Rp(R_grid,alphaTC).^(1-theta)];0];
for i=1:Ret-1;
    rho_grid(:,i+1) = 1./(1+(psi_grid(T-i+1,:)'+gamma*Q_grid(T-i+1,:)'.*(eta*FR_grid+eta*lambda*(1-FR_grid))).^(1/theta).*(1+eta*FR_grid+eta*lambda*(1-FR_grid)).^(-1/theta));
    alpha = @(R,FR,alpha_start) fsolve(@(alpha) gamma*w_grid*[Rp(R_grid,alpha).^(-theta).*(R_grid-Rf).*rho_grid(:,i+1).^(1-theta)+Rp(R_grid,alpha).^(-theta).*(R_grid-Rf).*(1-rho_grid(:,i+1)).^(1-theta).*Q_grid(T-i+2,:)']*(eta*FR+eta*lambda*(1-FR))...
           +beta*w_grid*[Rp(R_grid,alpha).^(-theta).*(1-rho_grid(:,i+1)).^(1-theta).*(R_grid-Rf)]...
           +beta*eta*(lambda-1)*w_grid*[w_grid*([[kron((Rp(R_grid,alpha).^(-theta).*(1-rho_grid(:,i+1)).^(1-theta).*(R_grid-Rf))',ones(n,1))-kron(Rp(R_grid,alpha).^(-theta).*rho_grid(:,i+1).^(1-theta).*(R_grid-Rf),ones(1,n))].*(kron(R_grid',ones(n,1))<kron(R_grid,ones(1,n)))])]'...
           +beta*gamma*eta*(lambda-1)*w_grid*([w_grid*([[kron((Rp(R_grid,alpha).^(-theta).*Q_grid(T-i+2,:)'.*(1-rho_grid(:,i+1)).^(1-theta).*(R_grid-Rf))',ones(n,1))-kron(Rp(R_grid,alpha).^(-theta).*Q_grid(T-i+2,:)'.*(1-rho_grid(:,i+1)).^(1-theta).*(R_grid-Rf),ones(1,n))].*(kron(R_grid',ones(n,1))<kron(R_grid,ones(1,n)))])]')...
           +beta*w_grid*[(1-rho_grid(:,i+1)).^(1-theta).*Rp(R_grid,alpha).^(-theta).*(R_grid-Rf).*psi_grid(T-i+2,:)'],alpha_start,options);
    for j=1:length(R_grid)
        alpha_grid(j,i+2) = alpha(R_grid(j),FR_grid(j),alpha_grid(j,i+1));
    end; alpha_grid(:,i+2) = min(max(alpha_grid(:,i+2),0),1); Rp_grid = Rf+kron(alpha_grid(:,i+2)',ones(n,1)).*(kron(R_grid,ones(1,n))-Rf);
    Rp_grid = Rf+kron(alpha_grid(:,i+2)',ones(n,1)).*(kron(R_grid,ones(1,n))-Rf);
    psi_grid(T-i,:) = beta*w_grid*[Rp_grid.^(1-theta)].*rho_grid(:,i+1)'.^(1-theta)+beta*w_grid.*(1-rho_grid(:,i+1)').^(1-theta)*[Rp_grid.^(1-theta)].*psi_grid(T-i+1,:);
    for j = 1:n; psi_grid(T-i,j) = psi_grid(T-i,j)+beta*eta*(lambda-1)*w_grid*[w_grid*[(kron(Rp_grid(:,j).^(1-theta)'.*rho_grid(:,i+1).^(1-theta)',ones(n,1))-kron(Rp_grid(:,j).^(1-theta).*rho_grid(:,i+1).^(1-theta),ones(1,n))).*(kron(Rp_grid(:,j)',ones(n,1))<kron(Rp_grid(:,j),ones(1,n)))]]'...
            +beta*gamma*eta*(lambda-1)*w_grid*([w_grid*[(kron(Rp_grid(:,j).^(1-theta)'.*Q_grid(T-i+1,:).*(1-rho_grid(:,i+1)).^(1-theta)',ones(n,1))-kron(Rp_grid(:,j).^(1-theta).*Q_grid(T-i+1,:)'.*(1-rho_grid(:,i+1)).^(1-theta),ones(1,n))).*(kron(Rp_grid(:,j)',ones(n,1))<kron(Rp_grid(:,j),ones(1,n)))]]'); 
    end; Q_grid(T-i,:) = beta*w_grid*[Rp_grid.^(1-theta)].*rho_grid(:,i+1)'.^(1-theta)+beta*w_grid*[Rp_grid.^(1-theta)].*(1-rho_grid(:,i+1)').^(1-theta).*Q_grid(T-i+1,:);
end
rho_grid(:,T+1) = 1./(1+(psi_grid(1,:)'+gamma*Q_grid(1,:)'.*(eta*FR_grid+eta*lambda*(1-FR_grid))).^(1/theta).*(1+eta*FR_grid+eta*lambda*(1-FR_grid)).^(-1/theta));
rhoTC = 1./(1+QTC_grid(1)^(1/theta)); rhoTC_grid(:,T+1) = rhoTC*ones(n,1);